/********************************************************************************
 * Copyright (C) 2017 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import { SelectionService } from '@devpodio/core/lib/common';
import { CommandContribution, CommandRegistry, Command } from '@devpodio/core/lib/common';
import { OpenerService } from '@devpodio/core/lib/browser';
import { CppLanguageClientContribution } from './cpp-language-client-contribution';
import { EditorManager } from '@devpodio/editor/lib/browser';
/**
 * Switch between source/header file
 */
export declare const SWITCH_SOURCE_HEADER: Command;
/**
 * A command that is used to show the references from a CodeLens.
 */
export declare const SHOW_CLANGD_REFERENCES: Command;
export declare const DUMP_INCLUSIONS: Command;
export declare const DUMP_INCLUDED_BY: Command;
export declare const REINDEX: Command;
export declare const PRINT_STATS: Command;
export declare const FILE_OPEN_PATH: (path: string) => Command;
export declare function editorContainsCppFiles(editorManager: EditorManager | undefined): boolean;
export declare class CppCommandContribution implements CommandContribution {
    protected readonly clientContribution: CppLanguageClientContribution;
    protected readonly openerService: OpenerService;
    private editorService;
    protected readonly selectionService: SelectionService;
    private readonly cppPreferences;
    constructor(clientContribution: CppLanguageClientContribution, openerService: OpenerService, editorService: EditorManager, selectionService: SelectionService);
    registerCommands(commands: CommandRegistry): void;
    protected switchSourceHeader(): Promise<void>;
    private dumpInclusions;
    private dumpIncludedBy;
    private reindex;
    private printStats;
}
//# sourceMappingURL=cpp-commands.d.ts.map