/********************************************************************************
 * Copyright (C) 2017 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import { BaseLanguageClientContribution, LanguageClientFactory, LanguageClientOptions, ILanguageClient } from '@devpodio/languages/lib/browser';
import { Languages, Workspace } from '@devpodio/languages/lib/browser';
import { ILogger } from '@devpodio/core/lib/common/logger';
import { WindowService } from '@devpodio/core/lib/browser/window/window-service';
import { CppStartParameters } from '../common';
import { CppBuildConfigurationManager, CppBuildConfiguration } from './cpp-build-configurations';
import { CppBuildConfigurationsStatusBarElement } from './cpp-build-configurations-statusbar-element';
import { CppPreferences } from './cpp-preferences';
export declare class CppLanguageClientContribution extends BaseLanguageClientContribution {
    protected readonly workspace: Workspace;
    protected readonly languages: Languages;
    protected readonly languageClientFactory: LanguageClientFactory;
    readonly id = "cpp";
    readonly name = "C/C++";
    protected readonly cppPreferences: CppPreferences;
    protected readonly cppBuildConfigurations: CppBuildConfigurationManager;
    protected readonly cppBuildConfigurationsStatusBarElement: CppBuildConfigurationsStatusBarElement;
    protected readonly windowService: WindowService;
    protected readonly logger: ILogger;
    constructor(workspace: Workspace, languages: Languages, languageClientFactory: LanguageClientFactory);
    protected init(): void;
    protected onReady(languageClient: ILanguageClient): void;
    private createClangdConfigurationParams;
    onActiveBuildConfigChanged(config: CppBuildConfiguration | undefined): Promise<void>;
    protected readonly documentSelector: string[];
    protected readonly globPatterns: string[];
    protected readonly configurationSection: string[];
    protected createOptions(): LanguageClientOptions;
    protected getStartParameters(): CppStartParameters;
}
//# sourceMappingURL=cpp-language-client-contribution.d.ts.map