/********************************************************************************
 * Copyright (C) 2017-2019 Ericsson and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import { BaseLanguageServerContribution, IConnection, LanguageServerStartOptions } from '@devpodio/languages/lib/node';
import { CppStartParameters } from '../common';
export interface CppStartOptions extends LanguageServerStartOptions {
    parameters?: CppStartParameters;
}
export declare class CppContribution extends BaseLanguageServerContribution {
    readonly id = "cpp";
    readonly name = "C/C++";
    start(clientConnection: IConnection, { parameters }: CppStartOptions): Promise<void>;
    protected testSupportsClangTidy(command: string): Promise<boolean>;
}
//# sourceMappingURL=cpp-contribution.d.ts.map